package com.cool.hot100.backtracking;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;

/**
 * Created with IntelliJ IDEA.
 *
 * @Author: Cool
 * @Date: 2024/09/10/14:21
 * DayNumber 2
 * Hard 2
 * Level ?
 */
public class Num39 {

    List<List<Integer>> resList = new ArrayList<>();
    int maxIndex;
    List<Integer> list = new ArrayList<>();

    public List<List<Integer>> combinationSum(int[] candidates, int target) {
        Arrays.sort(candidates);
        for (int i = 0; i < candidates.length; i++) {
            if (candidates[i] > target) {
                maxIndex = i - 1;
                break;
            } else if (i == candidates.length - 1) {
                maxIndex = i;
            }
        }
        if (candidates[0] > target || maxIndex < 0) {
            return resList;
        }
        dfs(candidates, target, maxIndex);
        return resList;
    }

    private void dfs(int[] candidates, int target, int index) {
        if (target == 0) {
            resList.add(new ArrayList<>(list));
            return;
        }
        if (target < 0 || index < 0) {
            return;
        }
        if (candidates[index] <= target) {
            list.add(candidates[index]);
            dfs(candidates, target - candidates[index], index);
            list.remove(list.size() - 1);
        }
        dfs(candidates, target, index - 1);
    }


}
