package com.cool.week_match.week417;

import org.junit.Test;

import java.util.Deque;
import java.util.LinkedList;
import java.util.Queue;

/**
 * Created with IntelliJ IDEA.
 *
 * @Author: Cool
 * @Date: 2024/09/29/10:51
 * @Description:
 */
public class Q1 {

    public char kthCharacter(int k) {
        if (k == 0) {
            return ' ';
        }
        Deque<Character> queue = new LinkedList<>();
        queue.offerLast('a');
        while (queue.size() < k) {
            char c = queue.pollFirst();
            char next;
            if (c == 'z') {
                next = 'a';
            } else {
                next = (char) (c + 1);
            }
            queue.offerLast(c);
            queue.offerLast(next);
        }
        while (queue.size() > k) {
            queue.pollLast();
        }
        return queue.peekLast();
    }
    @Test
    public void test(){
        kthCharacter(5);
    }
}
